#if !defined RAPIDQW32_H
#define RAPIDQW32_H

#include "rqapplication.h"
#include "rqbutton.h"
#include "rqbitmap.h"
#include "rqedit.h"
#include "rqform.h"
#include "rqlabel.h"
#include "rqmainmenu.h"
#include "rqmenuitem.h"
#include "rqcombobox.h"
#include "rqlistbox.h"
#include "rqstatusbar.h"
#include "rqdefs.h"
#include "rqstring.h"
#include "rqwinfunc.h"

#define String RQString

#ifdef _MSC_VER            // MS VC++
// I guess token pasting isn't as well defined...
#define RQ_INITIALIZE(wndProc) RQApplication application; \
                     int32 RQControl::controlCount = 0; \
                     LRESULT CALLBACK WindowProcedure (HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam) { \
                     return application.doEvents(hWnd, uMsg, wParam, lParam); }
#else
#define RQ_INITIALIZE(wndProc) RQApplication application; \
                     int32 RQControl::controlCount = 0; \
                     LRESULT CALLBACK (##wndProc) (HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam) { \
                     return application.doEvents(hWnd, uMsg, wParam, lParam); }
#endif

#define BEGIN_GUI int WINAPI WinMain (HINSTANCE hInst, HINSTANCE hPrevInst, char *cmdParam, int cmdShow) { application.setInstance(hInst);

#define BEGIN_CONSOLE int main (int argc, char **argv) {

#define END_GUI return 0; }
#define END_CONSOLE return 0; }

#define RQ_LEN(s) String(s).length()

#define RQ_PRINT(s) cout << s;
#define RQ_PRINTLN cout << endl;

#endif
