#if !defined RQAPPLICATION_H
#define RQAPPLICATION_H

#include <windows.h>
#include "rqcontrol.h"
#include "rqlist.h"
#include "rqdefs.h"

class RQApplication: public RQControl
{
private:
    RQList controlList;

public:
    RQApplication();
    ~RQApplication();

    void addControl(RQControl&);
    RQControl* findControlByHWND(HWND handle);
    RQControl* findControlByID(int32 ID);
    void deleteControl(RQControl&);
    LRESULT CALLBACK doEvents(HWND, UINT, WPARAM, LPARAM);

    int32 count;
};

#endif
